#include <dos.h>
#include <math.h>
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <stdarg.h>
#include <setjmp.h>
#include <allegro.h>

#define G 6.67259E-11    /* Nm/kg */

/* F = G * m1 * m2 / r */

/* a(1) = G * m2 / r */

char M_Func[256] = "G 1E8 *";
char A_Func[256] = /*"0";*/"index 70 count / *";
char D_Func[256] = /*"0";*/"index 100 count / *";
char N_Func[256] = /*"0";*/"R 5 mod 40 * 80 -";
char X_Func[256] = "400 R RMAX / * 200 -";
char Y_Func[256] = "40 R RMAX / * 30 -";
char Z_Func[256] = "400 R RMAX / * 200 - 100 +";

static int Count   =0;
static int mz      =10;
static int ObjCount=200;

static jmp_buf error;

int Error(const char *fmt, char *item)
{
	fprintf(stderr, "Error: ");
    fprintf(stderr, fmt, item);
    longjmp(error, 1);
}

float Laske(char *func, float m,float a,float d,float n,float x,float y,float z)
{
	int _;
    char Item[256];

    float Stack[32];
    int StackTop=0;

    for(;;)
    {
        while(*func==' ')func++;
	    for(_=0; func[_]!=' '&&func[_]; _++)Item[_]=func[_];
    	Item[_]=0;

        #define PUSH(a) \
        	StackTop<31 \
            	?	Stack[StackTop++] = (a) \
        		:	Error("Stack overflow at '%s'\n", Item)

        #define POP() \
            StackTop \
            	?	Stack[--StackTop] \
            	:	Error("Stack underflow at '%s'\n", Item)

             if(!strcmp(Item, "G"))PUSH(G);
        else if(!strcmp(Item, "A"))PUSH(a);
        else if(!strcmp(Item, "D"))PUSH(d);
        else if(!strcmp(Item, "N"))PUSH(n);
        else if(!strcmp(Item, "R"))PUSH(rand());
        else if(!strcmp(Item, "RMAX"))PUSH(RAND_MAX);
        else if(!strcmp(Item, "index"))PUSH(Count);
        else if(!strcmp(Item, "count"))PUSH(ObjCount);
        else if(!strcmp(Item, "mz"))PUSH(mz);
        else if(!strcmp(Item, "x"))PUSH(x);
        else if(!strcmp(Item, "y"))PUSH(y);
        else if(!strcmp(Item, "z"))PUSH(z);
        else if(!strcmp(Item, "-")){float b=POP(),a=POP();PUSH(a-b);}
        else if(!strcmp(Item, "+")){float b=POP(),a=POP();PUSH(a+b);}
        else if(!strcmp(Item, "/")){float b=POP(),a=POP();PUSH(a/b);}
        else if(!strcmp(Item, "*")){float b=POP(),a=POP();PUSH(a*b);}
        else if(!strcmp(Item, "mod")){float b=POP(),a=POP();PUSH(fmod(a,b));}
        else if(!strcmp(Item, "sin")){float a=sin(POP());PUSH(a);}
        else if(!strcmp(Item, "cos")){float a=cos(POP());PUSH(a);}
        else
        {
        	char *e;
        	PUSH(strtod(Item, &e));
            if(*e)Error("Invalid constant '%s'\n", Item);
        }

        if(!func[_])break;
        func += _;
    }
    return POP();
};

class Obj
{
public:
	float m;        /* Massa      */
    float x,y,z;    /* Sijainti   */

    float fx,fy,fz;

    float vx,vy,vz; /* Vauhti     */
    float ax,ay,az; /* Kiihtyvyys */

    int r,g,b;

    float Radius;

    void SetMass(float M)
    {
    	m=M;
        Radius = pow(M*(3.0/PI),1.0/3.0);
        /* r=root3(3*V/pi) */
    }

    ~Obj(void)
    {
    }
    Obj(void);
}*Objs;

Obj::Obj(void)
{
    hsv_to_rgb(rand()*300.0/RAND_MAX,1,1, &r,&g,&b);

    float a,d,n;

    a = d = n = 0.0;

    /*
    SetMass(Laske(M_Func, m,a,d,n,x,y,z));
    a =     Laske(A_Func, m,a,d,n,x,y,z);
    d =     Laske(D_Func, m,a,d,n,x,y,z);
    n =     Laske(N_Func, m,a,d,n,x,y,z);
    x =     Laske(X_Func, m,a,d,n,x,y,z);
    y =     Laske(Y_Func, m,a,d,n,x,y,z);
    z =     Laske(Z_Func, m,a,d,n,x,y,z);
    */

    SetMass(G * 1E8);

	a = Count * (70.0/ObjCount);
    d = Count * (100.0 / ObjCount);//rand()*100.0/RAND_MAX;

    n = -80 + (rand()%5)*40;

    x = d*sin(a) * Count + n;
    y = -40.0 + rand()/RAND_MAX - (((int)n*7)%50);
    z = d*cos(a) * Count + n/10 + 100.0;

    vx = vy = vz = 0.0;

    Count++;
}

int Sorter(const void *a, const void *b)
{
	return (int)(Objs[*((int *)b)].z - Objs[*((int *)a)].z);
}

void Draw(void)
{
	BITMAP *bm = create_bitmap(SCREEN_W,SCREEN_H);
    set_clip(bm, 0,0, SCREEN_W-1,SCREEN_H-1);

    rectfill(bm, 0,         0,SCREEN_W-1,SCREEN_H/2-1, 0);
    rectfill(bm, 0,SCREEN_H/2,SCREEN_W-1,SCREEN_H-1, makecol(0,0,90));

    int a, b, ObjList[ObjCount];

    for(a=0; a<ObjCount; a++)
    	ObjList[a]=a;

    qsort(ObjList, ObjCount, sizeof(int), Sorter);

    for(b=0; b<ObjCount; b++)
    {
    	a = ObjList[b];

        register float px,py,pz;

        pz=Objs[a].fz;

        if(pz < mz+1)break;

        px=Objs[a].fx;
        py=Objs[a].fy;

        float x, y;
        int c, R = (int)(Objs[a].Radius*1000/(pz-mz + fabs(px) + fabs(py)));

        x = (1.0 + 1.0 * px / pz) * SCREEN_W / 2;
		y = (1.0 + 1.0 * 60.0/pz) * SCREEN_H / 2;

        c = (int)(255*90/(pz-mz));
        if(py >= 60.0)c/=2;
        if(c>255)c=255;
        if(c<0)c=0;
		if(py >= 60.0)
        	ellipsefill(bm, (int)x,(int)y, R,(int)(R*0.7), makecol(0,0,c*(255-90)/255+90));
        else
        {
        	ellipsefill(bm, (int)x,(int)y, R,(int)(R*0.7), makecol(0,0,c*(255-90)/255+90));

            int r = (int)(Objs[a].r * 40 / (pz-mz));
            int g = (int)(Objs[a].g * 40 / (pz-mz));
            int b = (int)(Objs[a].b * 40 / (pz-mz));
            int Ra=0,Ga=0,Ba=0;
            if(r<40)r=40; if(r>255){Ga+=r/2;Ba+=r/2;}
            if(g<35)g=35; if(g>255){Ra+=g/2;Ba+=g/2;}
            if(b<30)b=30; if(b>255){Ra+=b/2;Ga+=b/2;}
            if((r+=Ra)>255)r=255;
            if((g+=Ga)>255)g=255;
            if((b+=Ba)>255)b=255;
            c=makecol16(r,g,b);
    
    		x = (1.0 + 1.0 * px / pz) * SCREEN_W / 2;
    		y = (1.0 + 1.0 * py / pz) * SCREEN_H / 2;
            circlefill(bm, (int)x,(int)y, R, c);
            circle(bm, (int)x,(int)y, R, makecol16(r/2,g/2,b/2));
        }
    }

    blit(bm,screen, 0,0, 0,0, SCREEN_W,SCREEN_H);
    destroy_bitmap(bm);
}

int a, b;
float m;

int ClearCGets=1;
#include "string.h"
void CGetsPStrWrite(unsigned char *s)
{
    int a = *s;
    while(a)putch((a--, *++s));
}
void CGetsAddChar(int Ch, int &CurX, unsigned char *&Str, int &wx, int &Insert)
{
    switch(Ch)
    {
        case 8:
            if(CurX > 0)
            {
                memmove(&Str[CurX+1], &Str[CurX+2], Str[1]-CurX+1);
                Str[1]--;
                CurX--;
                gotoxy(wx, wherey());
                CGetsPStrWrite(Str+1);
                putch(' ');
            }
            break;
        default:
            gotoxy(wx+CurX, wherey());
            putch(Ch);
            if(Insert)
            {
                memmove(&Str[CurX+3], &Str[CurX+2], Str[1]-CurX);
                Str[CurX+2] = Ch;
                if(Str[1] < Str[0])Str[1]++;
                gotoxy(wx, wherey());
                CGetsPStrWrite(Str+1);
            }
            else
                Str[CurX+2] = Ch;

            if(CurX < Str[0])CurX++;
    }
}

unsigned char *CGets(unsigned char *Str)
{
    int wx, CurX;
    int Insert;
    int a;

    wx = wherex();
    Insert = 1;
    Str[0]--;
    if(ClearCGets)
    {
        Str[1] = 0;
        CurX   = 0;
    }
    else
    {
        CGetsPStrWrite(Str+1);
        CurX = Str[1];
    }
    for(;;)
    {
        gotoxy(wx+CurX, wherey());
        a = getch();
        switch(a)
        {
            case 27:
            {
                int c;
                gotoxy(wx, wherey());
                for(c=Str[0]; c>0; c--)putch(' ');
                Str[1] = CurX = 0;
                break;
            }
            case 0:
                switch(getch())
                {
                    case 'G': CurX=0; break;
                    case 'O': CurX=Str[1]; break;
                    case 'K': if(CurX>0)CurX--; break;
                    case 'M': if(CurX<Str[1])CurX++; break;
                    case 'R': Insert = !Insert;
                    case 'S':
                        if(Str[1] > CurX)
                        {
                            memmove(&Str[2+CurX], &Str[3+CurX], Str[1]-CurX-1);
                            Str[1]--;
                            gotoxy(wx, wherey());
                            CGetsPStrWrite(Str+1);
                            putch(' ');
                        }
                }
                break;
            case '\r':
            case '\n':
                goto Skip;
            default:
                CGetsAddChar(a, CurX,Str,wx,Insert);
        }
    }
Skip:
    Str[Str[1]+2] = 0;
    return Str+2;
}

void Ask(const int dummy, ...)
{
	unsigned char *p, Buf[256];
    int y;
    va_list ap;

    textattr(7);
    clrscr();
    gotoxy(1, 1);

    cprintf("%s\r\n", dummy?"ERROR":"SELECT THE PARAMETERS");

    va_start(ap, dummy);
    for(y=1; (p=va_arg(ap,unsigned char *))!=NULL; y++)
    {
    	cprintf("%s", p);
    	unsigned char *s = va_arg(ap, unsigned char *);
    	if(*s)
    	{
        	cprintf(" [");
            if(!strcmp(s, "%d"))cprintf(s, *va_arg(ap, int *));
            else if(!strcmp(s, "%g"))cprintf(s, *va_arg(ap, float *));
            else cprintf(s, va_arg(ap, void *));
            cprintf("]");
        }
        cprintf("\r\n");
    }
    gotoxy(1, wherey()-y);
    va_end(ap);

    va_start(ap, dummy);
    for(y=0; (p=va_arg(ap,unsigned char *))!=NULL; y++)
    {
    	cprintf("%s", p);
    	unsigned char *s = va_arg(ap, unsigned char *);
    	if(*s)
    	{
        	va_list tmp = ap;
    		cprintf(" [");
            if(!strcmp(s, "%d"))cprintf(s, *va_arg(tmp, int *));
            else if(!strcmp(s, "%g"))cprintf(s, *va_arg(tmp, float *));
            else cprintf(s, va_arg(tmp, void *));
            cprintf("]: ");

            void *d = va_arg(ap, void *);

            Buf[0] = 255;
            CGets(Buf);
            p=Buf+2;
            while(isspace(*p))p++;
            if(!strcmp(s, "%s") && p[0])
            	strcpy(d, p);
            else
            	if(p[0])sscanf(p, s, d);
        }
        cprintf("\r\n");
    }
}

int main(int argc, char **argv)
{
P1: printf("GRAVITY SIMULATOR (C) 1999 Bisqwit (http://iki.fi/bisqwit/)\n\n");

	int a = setjmp(error);
	Ask(a,
    	"Minimum z value (mz) ", "%d", &mz,
        "Object count  (count)", "%d", &ObjCount,
        "Initial index (index)", "%d", &Count,
        "** These functions are processed in initialization\r\n"
        "** of each element, using \"the reverse polish logic\":","",
        "Mass function   (m)  ", "%s", M_Func,
        "Temp1 function  (A)  ", "%s", A_Func,
        "Temp2 function  (D)  ", "%s", D_Func,
        "Temp3 function  (N)  ", "%s", N_Func,
        "xcoord function (x)  ", "%s", X_Func,
        "ycoord function (y)  ", "%s", Y_Func,
        "zcoord function (z)  ", "%s", Z_Func,
        "** R=rand(), RMAX=RAND_MAX, sin=sin(), cos=cos(), G=6.67259E-11","",
        NULL);

    Objs = new Obj[ObjCount]();

	allegro_init();

    set_color_depth(16);
    if(set_gfx_mode(GFX_AUTODETECT, 640,480, 0,0) < 0)
    {
    	printf("Error setting gfx mode: %s\n", allegro_error);
        exit(EXIT_FAILURE);
    }

    for(;;)
    {
        Draw();

Retry:  if(kbhit())break;

		for(a=0; a<ObjCount; a++)
		{
        	Objs[a].ax = Objs[a].ay = Objs[a].az = 0.0;
            Objs[a].fx = /*fmod(*/Objs[a].x;//, 1000.0);
            Objs[a].fy = /*fmod(*/Objs[a].y;//, 1000.0);
            Objs[a].fz = /*fmod(*/Objs[a].z;//, 1000.0);
        }

        for(a=0; a<ObjCount; a++)
        {
            for(b=0; b<ObjCount; b++)
            	if(a != b)
                {
                	float dx = Objs[b].fx-Objs[a].fx;
                    float dy = Objs[b].fy-Objs[a].fy;
                    float dz = Objs[b].fz-Objs[a].fz;
                    //if(dx>500)dx=1000-dx;
                    //if(dz>500)dz=1000-dz;

                	float dist = sqrt(dx*dx + dy*dy + dz*dz);

                    if(dist < Objs[a].Radius+Objs[b].Radius)
                    {
                    	m = Objs[a].m + Objs[b].m;

                        sound((int)(m*1000.0));

                    	Objs[a].x = (Objs[a].x+Objs[b].x)/2;
                    	Objs[a].y = (Objs[a].y+Objs[b].y)/2;
                    	Objs[a].z = (Objs[a].z+Objs[b].z)/2;
                        Objs[a].vx =
                        	(Objs[a].vx*Objs[a].m +
                             Objs[b].vx*Objs[b].m) / m;
                        Objs[a].vy =
                        	(Objs[a].vy*Objs[a].m +
                             Objs[b].vy*Objs[b].m) / m;
                        Objs[a].vz =
                        	(Objs[a].vz*Objs[a].m +
                             Objs[b].vz*Objs[b].m) / m;

                        Objs[a].SetMass(m);

                        Objs[b] = Objs[--ObjCount];

                        delay(20);
                        nosound();

                        goto Retry;
                    }

                    float fperm = Objs[b].m / (dist * dist);

                	Objs[a].ax += dx * fperm;
                	Objs[a].ay += dy * fperm;
                	Objs[a].az += dz * fperm;
                }
        }
        for(a=0; a<ObjCount; a++)
        {
            Objs[a].x += (Objs[a].vx += Objs[a].ax);
            Objs[a].y += (Objs[a].vy += Objs[a].ay);
            Objs[a].z += (Objs[a].vz += Objs[a].az);
        }
    }
    do getch();while(kbhit());

    set_gfx_mode(GFX_TEXT, 80,25, 80,25);

    delete Objs;

    goto P1;

	return 0;
}

